import _Promise from 'babel-runtime/core-js/promise';
import ScriptLoader from './script-loader';
import config from './config';

var resolveModules = function resolveModules(modules) {
  return new _Promise(function (resolve, reject) {
    var globalRequire = window['require'];
    globalRequire(modules, function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      resolve(args);
    });
  });
};

/**
 * esri模块加载器，依赖于scriptLoader模块加载器
 */
export default {
  loadModules: function loadModules(modules) {
    if (window['require']) {
      return resolveModules(modules);
    } else {
      return ScriptLoader.loadScript(config.url).then(function () {
        return resolveModules(modules);
      }).catch(function (e) {
        console.error('load modules error', e);
      });
    }
  }
};